#ifndef READER_HPP__
#define READER_HPP__

#include <string>
#include <iostream>
#include <iomanip>
#include <fstream>
#include <cstdlib>
#include <vector>
#include <complex>
#include <numeric>
//#include <eigen3/Eigen/Core>
//#include <vtkImageFourierFilter.h>

//#define NDEBUG
#include <assert.h>

struct afvalues{
   unsigned int max;
   double cost;
};

struct bpm_params{
   unsigned int start;
   unsigned int min;
   unsigned int max;
};

struct FHRdata{
   std::vector<double> bpms;
   std::vector<double> cost;
};

std::vector<double> crosscorr(const std::vector<double>& signal, size_t maxlag);
std::vector<double> get_tri_window(const unsigned int tri_size, const unsigned int seg_size, const unsigned int maxelem);
afvalues get_af_params(const std::vector<double>& signal, const unsigned int tri_size, const unsigned int previous_max, const double fs, const bpm_params& bpm_range);
FHRdata get_heart_rates(const std::vector<double>& signal, const double& fs);
std::vector<double> decimate(const std::vector<double>& signal, const unsigned int& dec);
std::vector<double> freq_estimate(const std::vector<std::complex<double> >& signal, const unsigned int& N);
std::vector<double> read_times(const std::string& filename);
std::vector<std::complex<double> > read_samples(const std::string& filename);
void write_file(const std::string& filename, const std::vector<double>& data);


#endif
