%{
%dataset = [1 3 4 6 7 10];
clear all;
num = 6;
load data/PWDoppler06

%dataset = [2 3 4 6 7 6 10];
%setxlims = [5.5 9.5; 6.0 10.0; 0.0 10.0; 3.0 10.5; 10.0 16.0; 36.5 57.5; 22.5 34.5];
%dataset = 2;
%setxlims = [5.5 9.5];
%setxlims = [36.5 40.5];
%p = 1;

times = DopplerData.times;

%% Spectrum

% Time axis resolution
dt = DopplerData.times(2) - DopplerData.times(1);

% Sampling frequency 
fs = length(DopplerData.data) / (length(DopplerData.times) * dt);

% Highpass filtering to remove clutter
hpcutoff = 0.4;
[b,a] = butter(2, hpcutoff, 'high');
iq_f = filter(b, a, double(DopplerData.data));

% Window length
W = 32;
% Overlap percent
overlap = 0.75;
% Window function
ham = hamming(W)';

step = round(W * (1 - overlap));

col = 1;
for i = 0 : step : length(DopplerData.data) - W
    pw_spectrum(:, col) = fftshift(fft(ham .* iq_f(i + 1 : i + W), 256))';
    col = col + 1;
end

figure(6)
gain = -80;
dyn = 80;
spectrum_log = 256 * (gain + 20 * log10(abs(pw_spectrum))) / dyn;
image([times(1) times(end)], [0 256], spectrum_log)
colormap(gray(256))
%xlim(setxlims - [0.5 0.0])
set(gca, 'XlimMode', 'manual');

size(spectrum_log)
%imwrite(spectrum_log, colormap(gray(256)), ['Spectrum00', num2str(num), '.png'])
%}

%% Manual detection of heart cycles

n = 1;
while (true)
    [px,py] = ginput(1); 
    inputs(n) = px;
    n = n + 1;
end

%% Manual reference
clear all;
load data/PWDoppler03;

times = DopplerData.times;

%imwidth = 4966; % 02
imwidth = 4922; % 03
%imwidth = 5092; % 04
%imwidth = 4361; % 06
%imwidth = 5092; % 07
%imwidth = 7741; % 006
%imwidth = 5939; % 0010

% seconds per pixel
spp = (times(end) - times(1)) / imwidth;

% 02, manual:
%inputs = [1594 1734 1874 2014 2153 2292 2431 2572 2710 2851 2988] * spp;
% 03, manual:
inputs = [1941 2076 2208 2341 2472 2605 2738 2876 3007 3136 3270 3404 3536 3660 3795 3925 4061 4193 4327 4453 4605 4736 4871] * spp;
% 04, manual:
%inputs = [72 208 343 478 613 747 882 1016 1151 1285 1418 1552 1686 1820 1954 2087 2220 2354 2487 2620 2753 2888 3024 3157 3290] * spp;
% 06, manual:
%inputs = [133 270 406 544 646 748 890 1029 1167 1305 1445 1584 1722 1861 2000 2140 2278 2418 2556 2694 2832 2971 3109 3247] * spp;
% 07, manual:
%inputs = [3183 3319 3464 3629 3873 4133 4359 4595 4819 5024] * spp;
% 006, manual:
%inputs = [505 650 798 946 1094 1242 1388 1540 1684 1830 1974 2117 2261 2402 2544 2685 2827 2967 3109 3250 3395 3536 3677 3817 3955 4099 4239 4382 4521 4661 4799 4939 5078 5219 5358 5498 5636 5775 5912 6050 6188 6323 6459 6599 6728 6871 7006 7138 7277 7409] * spp;
% 0010, manual:
%inputs = [1478 1612 1746 1880 2017 2144 2278 2410 2544 2677 2808 2942 3077 3212 3343 3477 3608 3742 3878 4012 4145 4280 4416 4552 4686 4819 4954 5087 5222 5353 5490 5626 5762 5896] * spp;

%diff = inputs(2 : end) - inputs(1 : end - 1)

dts_manual = zeros(length(inputs) - 3, 2);

for j = 1 : length(inputs) - 3
    dt = (inputs(j + 3) - inputs(j)) / 3;
    t = 0.5 * (inputs(j) + inputs(j + 3));
    dts_manual(j, :) = [t + times(1) dt];
end

bpms_manual = zeros(length(dts_manual), 3);

for j = 1 : length(dts_manual)
    bpm_manual = 60 / dts_manual(j, 2);
    bpms_manual(j, :) = [dts_manual(j, :) bpm_manual];
end

save('manual03.mat', 'bpms_manual');

%{
%% Plotting
figure(6)
hold on
gain = -80;
dyn = 80;
spectrum_log = 256 * (gain + 20 * log10(abs(pw_spectrum))) / dyn;
image([times(1) times(end)], [0 256], spectrum_log)
colormap(gray(256))
%xlim([setxlims(p, 1) setxlims(p, 2)])
%set(gca, 'XlimMode', 'manual');

% Manual reference
scatter(bpms_manual(:, 1), bpms_manual(:, 2), 50, 'fill')
% Normal heart rate reference
ref = linspace(140, 140, length(spectrum_log));
plot(ref)
xlim([times(1) times(end)])
%xlim([setxlims(p, 1) setxlims(p, 2)])
ylim([0 256])
%}
